// Fabien HENON * 1998
// a render of our toy microscope (my brother and I)
// 100 % CSG modelled objects
// to render with povray 3.0 -> povray 3.7

// remove or add focal blur line 17 -> 25
// remove or add soft lights line 82 -> 92





camera {
        location <-140+clock*120,190-clock*70,-160+clock*160>

        //angle 170
/*
    focal_point <20,190,0>    // pink sphere in focus
    aperture 5   // a nice compromise
  //  aperture 0.05    // almost everything is in focus
  //  aperture 1.5     // much blurring
  //  blur_samples 4       // fewer samples, faster to render
    blur_samples 500     // more samples, higher quality image
	variance 1/10000
    confidence 0.99*/
        look_at  <-20,105,0>
}

//plane { z,0 pigment { rgb <1,0,0>}}
//plane { x,20 pigment { rgb <0,0,1>}}

//sphere { <20,190,0>,15 pigment { rgb <1,0,0>}}

#global_settings {
max_trace_level 20
assumed_gamma 2.5

            /* radiosity {
                           brightness 1.3
                           count 130
                           //distance_maximum 30
                           error_bound 0.3
                           gray_threshold 0.6
                           low_error_factor 0.1
                           minimum_reuse 0.01
                           recursion_limit 2}
*/

}


#declare centre=  <-10.289561, 0.0, 0.39741>+<20,123,0>


#include "surfaces.inc"

#include "molette.inc"

#include "vis.inc"

#include "pot.inc"

#include "plateau.inc"

#include "ess.inc"

//background { color rgb 0.1 }



    light_source {  <0, 1000, -200>
        color rgb 0.65

        spotlight
        point_at <0, 110, 0>
        radius 18
        falloff 22
        tightness 5
    }
    light_source {  <1000, 1000, -1000>
        color rgb <0.9,0.8,0.75>*1.5
        //area_light <66.7067, 137.417, 204.124>, <121.742, -19.6796, 102.062>, 16, 16  adaptive 2
        spotlight
        point_at <0, 110, 0>
        radius 8
        falloff 12
        tightness 5
    }
    light_source {  <-650, 600, -1000>
        color rgb<1, 0.97, 0.9>*1.5

        //area_light <-154.451, 53.3381, 155.563>, <-2.2254, 126.669, 77.7817>, 16, 16  adaptive 2
        spotlight
        point_at <0, 110, 0>
        radius 13
        falloff 17
        tightness 5
    }



#declare tete=
intersection {
cylinder { <57,55,-42>,<57,55,42>,10 inverse}
box { <47,55,-42>,<57,66,42> }
bounded_by { box { <47,55,-42>,<57,66,42> }}
}

#declare obj=
prism {
  linear_sweep
  cubic_spline
  -41,41
  16  // control points
  <29.373018, 33.817184>,
  <-26.725111, 32.602425>,
  <-26.748255, -2.352064>,
  <104.082498, -1.648656>,
  <100.597732, 16.625338>,
  <91.173398, 20.162905>,
  <87.633475, 24.791219>,
  <80.546893, 37.991281>,
  <74.348101, 52.343967>,
  <65.71329, 61.245631>,
  <51.523557, 66.799091>,
  <46.674781, 59.768491>,
  <43.473311, 39.751946>,
  <29.373018, 33.817184>,
  <-26.725111, 32.602425>,
  <-26.748255, -2.352064>

  rotate -x*90
  }


#declare pied=
difference {

object { obj }
cylinder { <0,0,0>,<0,66,0>,41.5 scale <3.13,1,1> inverse }
plane { x,100 inverse}
plane { x,-27 }
cylinder { <0,-1,0>,<0,35,0>,27 scale <2.12,1,1> }
box { <-28,22,-42>,<20,66,42> }
cylinder { <20,49,-42>,<20,49,42>,27 }
box { <20,49,-42>,<47,66,42> }
box { <20,25,-7.5>,<100,66,7.5> }               //creux du milieu
box { <-7,-1,-42>,<80,2,42> }
cone { <-27,72,-53>,50,<101,62,-53>,40 }
box { <-27,62,-30>,<100,66,-13> }
cone { <-27,72,53>,50,<101,62,53>,40 }
box { <-27,62,13>,<100,66,30> }

cylinder { <57,55,-42>,<57,55,42>,3 }

//object { tete }
//plane { y,0 rotate <0,0,-45> translate <67,65,0> inverse}
bounded_by { box { <-27,0,-42>,<100,65,42> }}
texture { text_1 }
}

object { pied }

prism {
  linear_sweep
  cubic_spline
  -6.0,6.0
  27  // control points
  <-5.0, 20.0>,
  <-7.330579, 20>,
  <-13.0, 20.0>,
  <-13.0, 0.0>,
  <-13.0, -30.0>,
  <0.0, -28.0>,
  <32.0, 0.0>,
  <43.0, 24.0>,
  <40.983475, 47.628109>,
  <30.0, 73.0>,
  <15.0, 98.0>,
  <0.0, 118.0>,
  <0.0, 98.0>,
  <0.0, 81.0>,
  <9.614525, 85.001318>,
  <19.625119, 64.331238>,
  <23.305792, 46.008262>,
  <25.0, 28.0>,
  <24.0, 21.0>,
  <21.0, 18.0>,
  <17.330579, 15.669421>,
  <11.0, 14.0>,
  <3.363629, 15.661158>,
  <-3, 20.0>,
  <-5.0, 20.0>,
  <-7.330579, 20>,
  <-13.0, 20>
  rotate -x*90
  translate <57,55,0>
texture { text_1 }
}

difference {
box { <-18,80,-8>,<2,118,8> }
cylinder { <2,79,-8>,<2,121,-8>,2 }
cylinder { <2,79,8>,<2,121,8>,2 }
bounded_by { box { <-18,80,-8>,<4,120,8> } }
pigment { color rgb <0.1,0.4,0.1> }
translate <57,55,0>
texture { text_1 }
}

#declare plateau=
union {
box { <-28,16,-16>,<-8,20,16> }
        intersection {
        cylinder { <-8,20,-16>,<-8,20,16>,4 }
        plane { y,20 }
        bounded_by { box { <-12,16,-16>,<-4,20,16> }}
}
texture { text_1 }
translate <57,55,0> }

object { plateau }

object { mirroir }

object { vis
rotate x*-90
translate <57,55,-14>
texture { chrome }
}

object { vis
rotate x*90
translate <57,55,14>
texture { chrome }
}

object {
bloc translate <20,123,0>
texture { text_1 }
}

///////////
#include "roue.inc"
object { roue texture { chrome }}



box { <20,135,-8>,<38,173,8> texture { text_1 }}



#include "optique.inc"


#include "tile.inc"



// ******** dome ********


  sphere{<0,0,0>,10000
    finish { ambient 0.7 diffuse 1 }
    pigment{
      image_map {
        png "dome.png"
        map_type 1
      }
    }
  }
